#include <cstdio>
#include <cstdlib>
#include <vector>

using namespace std;

int N;
vector<int> dobarStupac[ 8 ];
int dobarRedak[ 8 ][ 8 ][ 256 ] = { 0 };

int ploca[ 8 ][ 8 ];
int configRed[ 8 ] = { 0 }, minConfigRed[ 8 ];
int minBrojObrisanih = 64;
int brojRjesenja = 0;

int dvaNa[ 9 ] = { 1, 2, 4, 8, 16, 32, 64, 128, 256 };

bool moze( int r, int kombi, int dulj, bool jelRedak )
{
	int ima[ 10 ] = { 0 };
	if( jelRedak )
	{
		for( int s = 0; s < dulj; ++s )
		{
			if( ( kombi & dvaNa[ s ] ) == 0 )
				if( ima[ ploca[ r ][ s ] ] )
					return false;
				else
					ima[ ploca[ r ][ s ] ] = 1;
		
			if( s > 0 && ( kombi & dvaNa[ s ] ) && ( kombi & dvaNa[ s-1 ] ) )
				return false;
		}
	}
	else
	{
		int s = r;
		for( r = 0; r < dulj; ++r )
		{
			if( ( kombi & dvaNa[ r ] ) == 0 )
				if( ima[ ploca[ r ][ s ] ] )
					return false;
				else
					ima[ ploca[ r ][ s ] ] = 1;

			if( r > 0 && ( kombi & dvaNa[ r ] ) && ( kombi & dvaNa[ r-1 ] ) )
				return false;
		}
	}

	return true;
}

void rek( int s, int brojObrisanih )
{
	if( s == N )
	{
		// nasli smo novu do sada najbolju kombinaciju
		if( brojObrisanih == minBrojObrisanih )
			++brojRjesenja;
		else if( brojObrisanih < minBrojObrisanih )
		{
			brojRjesenja = 1;
			for( int r = 0; r < N; ++r )
				minConfigRed[ r ] = configRed[ r ];	
				
			minBrojObrisanih = brojObrisanih;			
		}
	
/*
		for( int rr = 0; rr < N; ++rr )
			for( int ss = 0; ss < N; ++ss )
				if( configRed[ rr ] & dvaNa[ ss ] )
					printf( "*%c", ss == N-1 ? '\n' : ' ' );
				else
					printf( "%d%c", ploca[ rr ][ ss ], ss == N-1 ? '\n' : ' ' );
					
		printf( "mini --> %d\n\n", brojObrisanih );
*/

		return;
	}
	
	for( int k = 0; k < dobarStupac[ s ].size(); ++k )
	{
		// zalijepi kombinaciju k u stupac s
		for( int r = 0; r < N; ++r )
		{
			configRed[ r ] += ( ( dobarStupac[ s ][ k ] & dvaNa[ r ] ) != 0 ) * dvaNa[ s ];
			brojObrisanih += ( ( dobarStupac[ s ][ k ] & dvaNa[ r ] ) != 0 );
		}
			
		// provjeri jesu li do sada sagradjeni dijelovi reda ok
		bool isOk = true;
//		if( s == N-1 )
		for( int r = 0; r < N; ++r )
			if( !dobarRedak[ r ][ s ][ configRed[ r ] ] )
				isOk = false;
				
		// samo u ovom slucaju ima smisla isprobavati dalje (dozvoli == da prebrojimo koliko ima razlicitih rjesenja)
		if( isOk && brojObrisanih <= minBrojObrisanih )
			rek( s+1, brojObrisanih );
		
		// vrati sve natrag i probaj iducu kombinaciju
		for( int r = 0; r < N; ++r )
		{
			configRed[ r ] -= ( ( dobarStupac[ s ][ k ] & dvaNa[ r ] ) != 0 ) * dvaNa[ s ];
			brojObrisanih -= ( ( dobarStupac[ s ][ k ] & dvaNa[ r ] ) != 0 );
		}
	}
}

int main( void )
{
	scanf( "%d", &N );

	for( int r = 0; r < N; ++r )
		for( int s = 0; s < N; ++s )
			scanf( "%d", &ploca[ r ][ s ] );

	// generiraj sve dobre kombinacije (k) brisanja za svaki stupac (s)
	for( int s = 0; s < N; ++s )
		for( int k = 0; k < dvaNa[ N ]; ++k )
			if( moze( s, k, N, false ) )
				dobarStupac[ s ].push_back( k );

	// generiraj sve dobre kombinacije (k) brisanja za svaki pocetak (s elemenata) svakog retka (r)
	for( int r = 0; r < N; ++r )
		for( int s = 0; s < N; ++s )
			for( int k = 0; k < dvaNa[ s+1 ]; ++k )
				if( moze( r, k, s+1, true ) )
					dobarRedak[ r ][ s ][ k ] = 1;

	rek( 0, 0 );

	// ispisi rjesenje
	for( int r = 0; r < N; ++r )
		for( int s = 0; s < N; ++s )
			if( minConfigRed[ r ] & dvaNa[ s ] )
				printf( "*%c", s == N-1 ? '\n' : ' ' );
			else
				printf( "%d%c", ploca[ r ][ s ], s == N-1 ? '\n' : ' ' );

	//printf( "\nBroj rjesenja = %d\n", brojRjesenja );
	
	//printf( "%d\n", dobarStupac[ 0 ].size() );
	
	return 0;
}
