#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLEN 20
#define YNLEN 2

int n;
char **words;
short reverse;
char *res;

void input()
{
	int f;
	char *buf;
	int tslen = 0;
	scanf("%d", &n);
	words = (char**)malloc(n * sizeof(char*));
	for (f = 0; f < n; ++f) {
		buf = (char*)malloc((MAXLEN + 2) * sizeof(char));
		scanf("%s", buf);
		tslen += strlen(buf);
		words[f] = buf;
	}
	buf = (char*)malloc((YNLEN + 2) * sizeof(char));
	scanf("%s", buf);
	reverse = (strcmp(buf, "DA") == 0);
	free(buf);
	res = (char*)malloc((tslen + 2) * sizeof(char));
}

void reverse_word(char *word) {
	int bi = 0, ei = strlen(word) - 1;
	char tmp;
	while (bi < ei) {
		tmp = word[bi];
		word[bi] = word[ei];
		word[ei] = tmp;
		++bi;
		--ei;
	}
}

int compute_overlap(char *word, char *res) {
	int rcp = strlen(res);
	int col = strlen(word);
	if (col > rcp) {
		col = rcp;
	}
	for (; col > 0; --col) {
		if (strncmp(res + rcp - col, word, col) == 0) {
			return col;
		}
	}
	return 0;
}

short compare_words(char *oldw, char *neww, char *res) {
	int o1, o2, l1, l2;
	o1 = compute_overlap(oldw, res);
	o2 = compute_overlap(neww, res);
	if (o1 > o2) return 0;
	if (o1 < o2) return 1;
	l1 = strlen(oldw);
	l2 = strlen(neww);
	if (l1 > l2) return 0;
	if (l1 < l2) return 1;
	return ((strcmp(oldw, neww) > 0)? 1 : 0);
}

int best_match_index(int n, char **words, short *used, char *res, short reverse) {
	int f;
	int bind = -1;
	for (f = 0; f < n; ++f) {
		if (used[f]) continue;
		if ((bind < 0) || (compare_words(words[bind], words[f], res))) {
			bind = f;
		}
	}
	if (reverse) {
		for (f = 0; f < n; ++f) {
			if (used[f]) continue;
			if ((bind < 0) || (compare_words(words[bind], words[n + f], res))) {
				bind = n + f;
			}
		}
	}
	return bind;
}

void compute()
{
	int f, znj;
	short *used = (short*)malloc(n * sizeof(short));
	memset(used, 0, n * sizeof(short));
	strcpy(res, words[0]);
	used[0] = 1;
	if (reverse) {
		words = (char**)realloc(words, 2 * n * sizeof(char*));
		for (f = 0; f < n; ++f) {
			words[n + f] = (char*)malloc((MAXLEN + 2) * sizeof(char));
			strcpy(words[n + f], words[f]);
			reverse_word(words[n + f]);
		}
	}
	for (znj = 1; znj < n; ++znj) {
		int bind = best_match_index(n, words, used, res, reverse);
		strcpy(res + strlen(res) - compute_overlap(words[bind], res), words[bind]);
		if (bind >= n) {
			bind -= n;
		}
		used[bind] = 1;
	}
	if (reverse) {
		for (f = 0; f < n; ++f) {
			free(words[n + f]);
		}
	}
	free(used);
}

void output()
{
	printf("%ld\n", strlen(res));
	printf("%s\n", res);
}

void cleanup()
{
	int f;
	for (f = 0; f < n; ++f) {
		free(words[f]);
	}
	free(words);
	free(res);
}

int main(void)
{
	input();
	compute();
	output();
	cleanup();
	return 0;
}
